/*	DAS'boot (tm) for Linux/16
	(C) 1995 Chad Page

	DAS'boot loads the system portion of the Linux/16 kernel image
	into memory, and starts it up.  This version works only with Linux/16
	versions 0.00.3.3 or higher.  I would say which older versions to use
	with older kernels here, but there aren't any :)

	This needs to be compiled as a large model program.
*/

#include <fcntl.h>
#include <sys/stat.h>
#include <io.h>
#include <alloc.h>
#include <dos.h>

unsigned int seg;

void main()
{
	int fd = open("system", O_BINARY);
	char far * ptr;
	long len;

	if (!fd)
		return;
	ptr = farmalloc(0x30000); /* Get 256K RAM */
	len = lseek(fd, 0, SEEK_END);
	/* The memory allocated offsets everything 4 bytes! */
	lseek(fd, 0, SEEK_SET);
	read(fd, ptr, 4);
	read(fd, ptr, len - 4);
	seg = FP_SEG(ptr) + 2;
	/* BAD HACK!  I'm assuming cs=seg, which BC++ 3.1 gives us... I'm
	 * suprized it worked like this :) */
	_asm {
		pushf
		push ax
		xor ax, ax
		push ax
		iret
	}
}
